/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#ifndef WIN32
#  include <unistd.h>
#  include <getopt.h>
#else
#  include <getopt_win32.h>
#endif
#include <CNCInterface.hpp>


int do_restart = 0;                 /* flag variables */
const char *ip = "localhost";       /* input IP address */
int iRecoveryMode = 0;

int argParse(int argc, char** argv) {
    struct option longopts[] = {
       { "nameserver",  optional_argument, NULL, 'n' },
       { "help",        no_argument,       NULL, 'h' },
       { 0, 0, 0, 0 }
    };

    int c;
    while ((c = getopt_long(argc, argv, ":hn:", longopts, NULL)) != -1) {
        switch (c) {
        case 'n':
            if (optarg != NULL)
               ip = optarg;
            break;
        case 'h':
            fprintf(stderr, "Usage: %s [<--nameserver | -n> [ip_address | localhost]] [--help | -h]\n",
                    argv[0]);
            return -1;
        case 0:     /* getopt_long() set a variable, just keep going */
            break;
#if 0
        case 1:
            /*
             * Use this case if getopt_long() should go through all
             * arguments. If so, add a leading '-' character to optstring.
             * Actual code, if any, goes here.
             */
            break;
#endif
        case ':':   /* missing option argument */
            fprintf(stderr, "%s: option '-%c' requires an argument\n",
                    argv[0], optopt);
            break;
        case '?':
        default:    /* invalid option */
            fprintf(stderr, "%s: option '-%c' is invalid: ignored\n",
                    argv[0], optopt);
            break;
        }
    }    
    return 0;
}

using namespace CNCControl;

int main(int argc, char** argv){
    int res = argParse(argc, argv);
    if (res < 0){
        fprintf(stderr, "Bad argument(s)!");
        return -1;
    }
    fprintf(stderr, "IP:%s\n", ip);
    CNCInterface iface("./lib");
    iface.connect(ip);
    iface.enableScriptLoading(false);
    std::string cmd;
    while(1) {
        //printf("%5s|%5s|%5s|%5s|%5s $ ", str0.c_str(), str1.c_str(), str2.c_str(), str3.c_str(), str4.c_str());
        std::getline(std::cin, cmd);
        if (cmd == "q" || cmd == "quit")
            break;
        else if (cmd == "p" || cmd == "POS"){
            printf("Not implemented yet!\n");
        } else if (cmd.substr(0,2) == "RB") {
            if (cmd.length() == 2) {
                int n = iface.getNumOfRobots();
                printf("Robots num = %d\n", n);
            } else {
                int i = strtol(cmd.substr(2).c_str(), NULL, 0);
                if (cmd.find("jog_start") != std::string::npos) {
                    int frame = 0, axis = 0;
                    std::size_t found = cmd.find("jog_start");
                    sscanf(cmd.substr(found).c_str(), "jog_start %d", &axis);
                    printf("Press any key to stop jogging\n");
                    iface.setCurrentRobot(i);
                    iface.servoOn(true);
                    if(axis == 1)
                        iface.jogRobotXaxis(0.1, true);
                    else if(axis == 2)
                        iface.jogRobotYaxis(0.1, true);
                    else if(axis == 3)
                        iface.jogRobotZaxis(0.1, true);
                    else if(axis == 4)
                        iface.jogRobotAaxis(0.1, true);
                    else if(axis == 5)
                        iface.jogRobotBaxis(0.1, true);
                    else if(axis == 6)
                        iface.jogRobotCaxis(0.1, true);
					else if(axis == -1)
                        iface.jogRobotXaxis(-0.1, true);
                    else if(axis == -2)
                        iface.jogRobotYaxis(-0.1, true);
                    else if(axis == -3)
                        iface.jogRobotZaxis(-0.1, true);
                    else if(axis == -4)
                        iface.jogRobotAaxis(-0.1, true);
                    else if(axis == -5)
                        iface.jogRobotBaxis(-0.1, true);
                    else if(axis == -6)
                        iface.jogRobotCaxis(-0.1, true);
                    else{
                        printf("Only accepting [1 - 6] axis");
                        continue;
                    }
                    while(!getchar());
                    iface.servoOn(false);
                    iface.endRobotJog();
                } else if (cmd.find("speed") != std::string::npos) {
                    std::size_t found = cmd.find("speed");
                    if (cmd.length() == found + 5) {
                        double speed;
                        int res = iface.getSpeed(speed, (BUnits)0);
//                        iface.setSpeed(speed, (BUnits)0);
                        printf("Robot %d speed = %f\n", i, speed);
                    } else {
                        int speed = strtol(cmd.substr(found+5).c_str(), NULL, 0);
                        iface.setSpeed(speed, (BUnits)0);
                    }
                } else if (cmd.find("table_frame") != std::string::npos){
                    std::size_t found = cmd.find("table_frame");
                    if (cmd.length() == found + 11){
                        int frame_no;
                        iface.getTableFrameNo(frame_no);
                        printf("Current Table Frame: %d\n", frame_no);
                    }
                    else{
                        int frame_no; 
                        sscanf(cmd.substr(found).c_str(), "table_frame %d", &frame_no);
                        int ret = iface.setTableFrameNo(frame_no);
                        if (ret < 0){
                            printf("Failed to set table frame no\n"); 
                        }
                    }
                } else if(cmd.find("path_trig") != std::string::npos){
                    std::size_t found = cmd.find("path_trig");
                    if (cmd.length() == found + 9){
                        std::vector<std::string> ports;
                        ports.push_back("sf0");
                        ports.push_back("sf1");
                        int res = iface.pathTrigger(ports, 0.9, 0, true);
                        if(res < 0){
                            printf("Failed to set path trigger (%d)\n", res);
                        }
                        else{
                            printf("Path trigger ports are set\n");
                        }
                    }
                } else if (cmd.find("calib_table") != std::string::npos){
                    std::size_t found = cmd.find("calib_table");
                    if (cmd.length() == found + 11){
                        double x,y,z,a,b,c;
                        iface.getTableFrame(x, y, z, a, b, c);
                        printf("Table Frame: X=%f, Y=%f, Z=%f, A=%f, B=%f, C=%f\n", x, y, z, a, b, c);
                        printf("cmd: RBn calib_table <step no.1,2,3>\n");
                    }
                    else{
                        int step_no=-1;
                        sscanf(cmd.substr(found).c_str(), "calib_table %d", &step_no);
                        iface.calibTable(step_no);
                        if(step_no == 1){
                            printf("Calibrated P1 (table frame origin)\n");
                        }
                        else if (step_no == 2){
                            printf("Calibrated P2 (point on +X axis)\n");
                        }
                        else if (step_no == 3){
                            printf("Calibrated P3 (point on XY plane)\n");
                        }
                        else{
                            printf("Step number must be either of 1, 2 or 3\n");
                        }
                    }
                } else if (cmd.find("lin") != std::string::npos){
                    std::size_t found = cmd.find("lin");
                    double x, y, z, spd;
                    sscanf(cmd.substr(found).c_str(), "lin %lf %lf %lf %lf", &x, &y, &z, &spd);
                    iface.setCurrentRobot(i);
                    iface.servoOn(true);
                    int res = iface.line(x, y, z, spd);
                    if(res != 0){
                        printf("Failed to execute lineto command (%d)\n", res);
                    }
                    else{
                        printf("Executing linto..\n");
                        iface.start();
                        printf("Press any key to stop\n");
                        while(!getchar());
                        iface.stop();
                    }
                    iface.servoOn(false);
                } else if (cmd.find("arc") != std::string::npos){
                    std::size_t found = cmd.find("arc");
                    double start, add, r, x, y, spd;
                    sscanf(cmd.substr(found).c_str(), "arc %lf %lf %lf %lf %lf %lf", &start, &add, &r, &x, &y, &spd);
					printf("Got parameters\n");
                    iface.setCurrentRobot(i);
                    iface.servoOn(true);
					printf("Calling ARC function\n");
                    int res = iface.arc(start, add, r, x, y, spd);
                    if(res != 0){
                        printf("Failed to execute arcto command (%d)\n", res);
                    }
                    else{
                        printf("Executing arcto..\n");
                        iface.start();
                        printf("Press any key to stop :");
                        while(!getchar());
                        iface.stop();
                    }
                    iface.servoOn(false);
                } else if(cmd.find("home") != std::string::npos) {
                    std::size_t found = cmd.find("home");
                    int joint = -1;
                    sscanf(cmd.substr(found).c_str(), "home %d", &joint);
                    if(joint > 6 || joint < 1) {
                        printf("Illegal joint number provided!\n");
                    } else {
                        iface.setCurrentRobot(i);
                        iface.servoOn(true);
                        int res = iface.homeJoint((JogJoint)joint, 0.1, 0.1);
                        if(res != 0) {
                            printf("Failed to execute home command (%d)\n", res);
                        }
                        else {
                            printf("Executing home..\n");
//                            iface.start();
                            printf("Press any key to stop :");
                            while(!getchar());
//                            iface.stop();
                        }
                        iface.servoOn(false);
                    }
                } else if(cmd.find("restart") != std::string::npos) {
                    int res = iface.restart();
                    if(res != 0){
                        printf("Failed to restart!\n");
                    } else {
                        printf("Restarting...\n");
                    }
                } else {
                    std::string name;
                    RobotInfo rinfo;
                    iface.getRobotInfo(i, rinfo);
                    name = rinfo.name;
                    printf("Robot %d name = %s\n", i, name.c_str());
                }
            }
        } else {
//            ioPrint = -1; //disable print IO.
        }
    }
    return 0;
}
